
import jnyqide.*;
import com.apple.mrj.*;
import javax.swing.SwingUtilities;

public class SpecialMacHandler
    implements MRJQuitHandler, MRJPrefsHandler, MRJAboutHandler {
    MainFrame us;
    public SpecialMacHandler(jnyqide.MainFrame theProgram) {
        us = theProgram;
        System.setProperty("com.apple.macos.useScreenMenubar", "true");
        System.setProperty("com.apple.mrj.application.apple.menu.about.name", "jNyqIDE");
        MRJApplicationUtils.registerAboutHandler(this);
        MRJApplicationUtils.registerPrefsHandler(this);
        MRJApplicationUtils.registerQuitHandler(this);
        System.out.println("\n\n\nRegistered handlers for Mac Application Menu\n\n\n");
    }
    public void handleAbout() {
        us.About();
    }
    public void handlePrefs() {
        us.Prefs();
    }
    public void handleQuit() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                us.Quit();
            }
        });
        throw new IllegalStateException("Let the quit handler do it");
    }
}


